<?php


/*
 *	Copyright  2010-2011 Edson Ordaz, nicedo_eeos@hotmail.com
 *
 *	This program is free software: you can redistribute it and/or modify
 *	it under the terms of the GNU General Public License as published by
 *	the Free Software Foundation, either version 3 of the License, or
 *	(at your option) any later version.
 *
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public License
 *	along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 *	@author Edson Ordaz <nicedo_eeos@hotmail.com>
 *        @websites:  http://www.mybb-es.com
 */
 
if(!defined("IN_MYBB")) {
    die("This file cannot be accessed directly.");
}

$plugins->add_hook("postbit", "SuscriberUser_postbit");
$plugins->add_hook("datahandler_post_insert_thread_post", "SuscribeUsers_pm");       
$plugins->add_hook("misc_start", "SuscribeUsers_add");
$plugins->add_hook("misc_start", "SuscribeUsers_quit");
$plugins->add_hook("misc_start", "SuscribeUsers_list_postbit");
$plugins->add_hook("member_profile_start", "SuscribeUsers_replace");
$plugins->add_hook("usercp_start", "SuscribeUsers_awaiting_run");
$plugins->add_hook("global_start", "newsususers_invitation");
$plugins->add_hook("usercp_suscriber_users_start", "newsususers_invitation_as_read");
$plugins->add_hook("build_friendly_wol_location_end", "suscriberusers_whosonline");
$plugins->add_hook("misc_start", "suscriberusers_suscribers_stats");


function SuscribeUsers_info() {
	global $lang;
	$lang->load("config_suscriberusers", false, true);	
	return array(
		'name'			=> $lang->info_name,
		'description'	=> $lang->info_des,
		'website'		=> 'mailto:nicedo_eeos@hotmail.com',
		'author'		=> 'Edson Ordaz',
		'authorsite'	=> 'mailto:nicedo_eeos@hotmail.com',
		'version'		=> "1.5",
		'guid'			=> "1a74975d037c81ca6cd45b734c9aafeb"
	);
}
function SuscribeUsers_is_installed(){
	global $mybb, $db;
  	if($db->table_exists("suscribeusers") && $db->table_exists("suscribeusers_awaiting"))
	{
		return true;
	}
}

function SuscribeUsers_install() 
{
	global $mybb, $db,$lang;
	$lang->load("config_suscriberusers", false, true);
  	if(!$db->table_exists("suscribeusers"))
	{
		$db->query("CREATE TABLE IF NOT EXISTS `".TABLE_PREFIX."suscribeusers` (
  `suid` smallint(5) unsigned NOT NULL AUTO_INCREMENT,
  `uid` varchar(120) NOT NULL DEFAULT '',
  `usid` varchar(120) NOT NULL DEFAULT '',
  `date` int(10) NOT NULL,
  PRIMARY KEY (`suid`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;");
	}
  	if(!$db->table_exists("suscribeusers_awaiting"))
	{
		$db->query("CREATE TABLE IF NOT EXISTS `".TABLE_PREFIX."suscribeusers_awaiting` (
  `asid` smallint(5) unsigned NOT NULL AUTO_INCREMENT,
  `uid` varchar(120) NOT NULL DEFAULT '',
  `usid` varchar(120) NOT NULL DEFAULT '',
  `date` int(10) NOT NULL,
  PRIMARY KEY (`asid`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;");
	}
	$suscriber_user_groups = array(
		"gid"			=> "NULL",
		"name"			=> "suscriberuser",
		"title" 		=> $lang->namegroup,
		"description"	=> $lang->namegroup_des,
		"disporder"		=> "0",
		"isdefault"		=> "no",
	);
	$db->insert_query("settinggroups", $suscriber_user_groups);
	$gid = $db->insert_id();
	$db->write_query("ALTER TABLE `".TABLE_PREFIX."users` ADD `numfollowers` INT(10) NOT NULL DEFAULT '0';");
	$db->write_query("ALTER TABLE `".TABLE_PREFIX."users` ADD `newsususers` INT(10) NOT NULL DEFAULT '0';");
	$suscriber_user = array(
	array(
		"name"			=> "suscriberuser_pathimage",
		"title"			=> $lang->path_image,
		"description"	=> $lang->path_image_des,
		"optionscode"	=> "text",
		"value"			=> "images/avatars/invalid_url.gif",
		"disporder"		=> 1,
		"gid"			=> $gid,
	),
	array(
		"name"			=> "suscriberuser_pagination",
		"title"			=> $lang->pagination,
		"description"	=> $lang->pagination_des,
		"optionscode"	=> "text",
		"value"			=> "3",
		"disporder"		=> 2,
		"gid"			=> $gid,
	),
	array(
		"name"			=> "suscriberuser_subject",
		"title"			=> $lang->subject,
		"description"	=> $lang->subject_des,
		"optionscode"	=> "text",
		"value"			=> $lang->value_subject,
		"disporder"		=> 3,
		"gid"			=> $gid,
	),
	array(
		"name"			=> "suscriberuser_body",
		"title"			=> $lang->body,
		"description"	=> $lang->body_des,
		"optionscode"	=> "textarea",
		"value"			=> $lang->value_body,
		"disporder"		=> 4,
		"gid"			=> $gid,
	),
	array(
		"name"			=> "suscriberuser_size_avatar",
		"title"			=> $lang->size_avatar,
		"description"	=> $lang->size_avatar_des,
		"optionscode"	=> "text",
		"value"			=> "100x100",
		"disporder"		=> 5,
		"gid"			=> $gid,
	),
	array(
		"name"			=> "suscriberuser_subject_accept",
		"title"			=> $lang->subject_accept,
		"description"	=> $lang->subject_accept_des,
		"optionscode"	=> "textarea",
		"value"			=> $lang->value_subject_accept,
		"disporder"		=> 6,
		"gid"			=> $gid,
	),
	array(
		"name"			=> "suscriberuser_body_accept",
		"title"			=> $lang->body_accept,
		"description"	=> $lang->body_accept_des,
		"optionscode"	=> "textarea",
		"value"			=> $lang->value_body_accept,
		"disporder"		=> 7,
		"gid"			=> $gid,
	),
	array(
		"name"			=> "suscriberuser_listfollower_perpage",
		"title"			=> $lang->followerlist_perpage,
		"description"	=> $lang->followerlist_perpage_des,
		"optionscode"	=> "text",
		"value"			=> 15,
		"disporder"		=> 8,
		"gid"			=> $gid,
	)
	);
	foreach($suscriber_user as $sus_us)
	$db->insert_query("settings", $sus_us);
	rebuildsettings();
}

function SuscribeUsers_uninstall(){
	global $mybb, $db;
	$db->query("DELETE FROM ".TABLE_PREFIX."settinggroups WHERE name='suscriberuser'");
	$db->delete_query("settings","name LIKE 'suscriberuser_%'");
	$db->write_query("ALTER TABLE `".TABLE_PREFIX."users` DROP `numfollowers`;");
	$db->write_query("ALTER TABLE `".TABLE_PREFIX."users` DROP `newsususers`;");
	$db->drop_table("suscribeusers");
	$db->drop_table("suscribeusers_awaiting");
}


function SuscribeUsers_activate() {
	global $mybb,$db,$templates;
	$suscriberusers_template	= array(
		"tid" => "NULL",
		"title" => "suscriberusers",
		"template" => $db->escape_string('<br />
<table border="0" cellspacing="{$theme[\'borderwidth\']}" cellpadding="{$theme[\'tablespace\']}" class="tborder">
<tr>
<td class="thead" colspan="2"><strong>{$lang->userssuscriberto}</strong></td>
</tr>
<tr>
{$users_suscribers}
</tr>
{$suscriber_new_user}
</table>
{$paginar}'),
		"sid" => "-1",
	);
	$suscriberusers_list_template	= array(
		"tid" => "NULL",
		"title" => "suscriberusers_list",
		"template" => $db->escape_string('<tr>
<td class="{$bgcolor}" align="center" valign="center">
{$avatar}
</td>
<td class="{$bgcolor}" >
<a href="member.php?action=profile&uid={$usuarios[\'usid\']}"><b>{$username}</b></a>
<br />
{$lang->messages}: {$user[\'postnum\']}<br />
{$lang->suscriberdate}: {$suscriberdate}<br />
{$lang->entry}: {$regdate}<br />
{$lang->lastvisit}: {$lastvisit}
</td>
</tr>'),
		"sid" => "-1",
	);
	$suscriberusers_new_template	= array(
		"tid" => "NULL",
		"title" => "suscriberusers_new_suscriber",
		"template" => $db->escape_string('<tr>
<td class="trow2" colspan="2">{$newsuscriber}</td>
</tr>'),
		"sid" => "-1",
	);
	$suscriberusers_empty_template	= array(
		"tid" => "NULL",
		"title" => "suscriberusers_empty",
		"template" => $db->escape_string('<td class="trow1"><font color="red" size="5"><center><strong>{$lang->notusersuscriber}</strong></center></font></td>'),
		"sid" => "-1",
	);
	$suscriberusers_postbit_template  = array(
		"tid" => "NULL",
		"title" => "suscriberusers_postbit",
		"template" => $db->escape_string('<br />
{$lang->follower}: <a href="javascript:MyBB.popupWindow(\'misc.php?action=suscriberuser&amp;uid={$post[\'uid\']}\', \'SuscriberUser\', 400, 300);">
<strong>{$post[\'suscriberusers\']}</strong></a>
<br />
{$userfallow}'),
		"sid" => "-1",
	);
	$suscriberusers_postbit_popup  = array(
		"tid" => "NULL",
		"title" => "suscriberusers_postbit_popup",
		"template" => $db->escape_string('<html>
<head>
<title>{$mybb->settings[\'bbname\']} - {$lang->suscribersuser}</title>
{$headerinclude}
</head>
<body>
<table border="0" cellspacing="{$theme[\'borderwidth\']}" cellpadding="{$theme[\'tablespace\']}" class="tborder">
<tr>
<td class="thead" colspan="2"><strong>{$lang->userssuscriberto}</strong></td>
</tr>
<tr>{$listsuscriberusers}</tr></table>
</body>
</html>'),
		"sid" => "-1",
	);
	$suscriberusers_postbit_popup_list  = array(
		"tid" => "NULL",
		"title" => "suscriberusers_postbit_popup_list",
		"template" => $db->escape_string('<tr>
<td class="{$bgcolor}" align="center" valign="center">
{$avatar}
</td>
<td class="{$bgcolor}">
<a href="member.php?action=profile&uid={$usuarios[\'usid\']}"><b>{$username}</b></a>
<br />
{$lang->messages}: {$user[\'postnum\']}<br />
{$lang->suscriberdate}: {$suscriberdate}<br />
{$lang->entry}: {$regdate}<br />
{$lang->lastvisit}: {$lastvisit}
</td>
</tr>'),
		"sid" => "-1",
	);
	$suscriberusers_usercp  = array(
		"tid" => "NULL",
		"title" => "suscriberusers_usercp",
		"template" => $db->escape_string('<html>
<head>
<title>{$mybb->settings[\'bbname\']} - {$lang->su_ucercp_title}</title>
{$headerinclude}
</head>
<body>
{$header}
<table width="100%" border="0" align="center">
<tr>
{$usercpnav}
<td valign="top">
{$errors}
<table border="0" cellspacing="{$theme[\'borderwidth\']}" cellpadding="{$theme[\'tablespace\']}" class="tborder">
<tr>
<td class="thead" colspan="2"><strong>{$lang->editsuscripcion}</strong></td>
</tr>
<tr>
<td class="trow1"><fieldset><legend><strong>{$lang->invitations_suscribers}</strong></legend>
{$tableawaiting}
</fieldset>
<br />
<fieldset><legend><strong>{$lang->subscribedtoyou}</strong></legend>
<ul id="suscribers_list" style="list-style: none;">
{$subscribedtoyou}
</ul>
</fieldset>
<br />
<fieldset><legend><strong>{$lang->userstofollow}</strong></legend>
<ul id="suscribers_list_you" style="list-style: none;">
{$subscribed_you}
</ul>
</fieldset>
</td>
</tr>
</table>
<br />
<div align="center">
</div>
</td>
</tr>
</table>
{$footer}
</body>
</html>'),
		"sid" => "-1",
	);
	$suscriberusers_usercp_usersawaiting  = array(
		"tid" => "NULL",
		"title" => "suscriberusers_usercp_usersawaiting",
		"template" => $db->escape_string('<form method="post" enctype="multipart/form-data" action="usercp.php">
<input type="hidden" name="my_post_key" value="{$mybb->post_code}" />
<tr colspan="2" class="{$bgcolor}">
<td width="65%">
<img src="images/icons/user.gif"> {$username}
</td>
<td align="center">
PM <input type="checkbox" class="checkbox" name="send_mp" checked/>
</td>
<td align="center">
<input type="hidden" name="date" value="{$suscriber_date}" />
<input type="hidden" name="uid" value="{$user[\'uid\']}" />
<input type="hidden" name="username" value="{$user[\'username\']}" />
<input type="hidden" name="action" value="do_suscriberawaiting" />
<input type="submit" class="button" name="accept_awaiting" value="{$lang->su_accept}" />
</td>
<td align="center">
<input type="submit" class="button" name="reject_awaiting" value="{$lang->su_reject}" />
</td>
</tr>
</form>'),
		"sid" => "-1",
	);
	$suscriberusers_usercp_tableawaiting  = array(
		"tid" => "NULL",
		"title" => "suscriberusers_usercp_tableawaiting",
		"template" => $db->escape_string('<table border="0" cellspacing="{$theme[\'borderwidth\']}" cellpadding="{$theme[\'tablespace\']}" class="tborder">
{$usersawaiting}
</table>'),
		"sid" => "-1",
	);
	$suscriberusers_usercp_userssuscribers  = array(
		"tid" => "NULL",
		"title" => "suscriberusers_usercp_userssuscribers",
		"template" => $db->escape_string('<li style="width: 33%; float: left; list-style: none; margin-bottom: 4px;" id="{$user[\'uid\']}">
<a href="usercp.php?action=do_deletesus&amp;my_post_key={$mybb->post_code}&amp;delete={$user[\'uid\']}" onclick="return confirm(\'{$lang->confirmdelete}\');" title="{$lang->remove_from_list}">
<img src="{$theme[\'imgdir\']}/buddy_delete.gif" title="[{$lang->delete}]"  alt="{$lang->remove_from_list}" style="vertical-align: middle;" />
</a>
{$username}
</li>'),
		"sid" => "-1",
	);
	$suscriberusers_alert_bar = array(
		"title"		=> 'suscriberusers_alert_bar',
		"template"	=> '<div class="pm_alert" id="comment_notice">
{$lang->textalertbar}
</div>',
		"sid"		=> -1,
		"version"	=> 1.0,
		"dateline"	=> time(),
	);
	$suscriberusers_top = array(
		"title"		=> 'suscriberusers_top',
		"template"	=> $db->escape_string('<html>
<head>
<title>{$mybb->settings[\'bbname\']} - {$lang->fanlist}</title>
{$headerinclude}
</head>
<body>
{$header}
<table border="0" cellspacing="{$theme[\'borderwidth\']}" cellpadding="{$theme[\'tablespace\']}" class="tborder">
<tr>
<td class="thead" colspan="6"><b>{$lang->follower}</b></td>
</tr>
<td class="tcat" width="1%"><span class="smalltext"><strong>{$lang->avatar}</strong></span></td>
<td class="tcat"><span class="smalltext"><strong>{$lang->user_name}</strong></span></td>
<td class="tcat" width="15%" align="center"><span class="smalltext"><strong>{$lang->regdate}</strong></span></td>
<td class="tcat" width="15%" align="center"><span class="smalltext"><strong>{$lang->lastvisit}</strong></span></td>
<td class="tcat" width="10%" align="center"><span class="smalltext"><strong>{$lang->messages}</strong></span></td>
<td class="tcat" width="10%" align="center"><span class="smalltext"><strong>{$lang->follower}</strong></span></td>
</tr>
{$top_followers}
</table>
{$pagination}
{$footer}
</body>
</html>'),
		"sid"		=> -1,
		"version"	=> 1.0,
		"dateline"	=> time(),
	);
	$suscriberusers_top_table = array(
		"title"		=> 'suscriberusers_top_table',
		"template"	=> $db->escape_string('<tr class="{$bgcolor}">
<td>{$user[\'avatar\']}</td>
<td valign="top">{$user[\'profilelink\']}
<br />
{$user[\'usertitle\']}
<br />
{$usergroup[\'groupimage\']}
{$user[\'userstars\']}</td>
<td align="center">{$user[\'regdate\']}</td>
<td align="center">{$user[\'lastvisit\']}</td>
<td align="center">{$user[\'postnum\']}</td>
<td align="center"><b>{$user[\'numfollowers\']}</b></td>
</tr>'),
		"sid"		=> -1,
		"version"	=> 1.0,
		"dateline"	=> time(),
	);
	$suscriberusers_postbit_userfollow = array(
		"title"		=> 'suscriberusers_postbit_userfollow',
		"template"	=> $db->escape_string('[<a href="member.php?action=profile&uid={$post[\'uid\']}">{$lang->userfollow}</a>]'),
		"sid"		=> -1,
		"version"	=> 1.0,
		"dateline"	=> time(),
	);
	$suscriberusers_usercp_userswhosuscribers = array(
		"title"		=> 'suscriberusers_usercp_userswhosuscribers',
		"template"	=> $db->escape_string('<li style="width: 33%; float: left; list-style: none; margin-bottom: 4px;" id="{$user[\'uid\']}">
<a href="usercp.php?action=do_deletesuswho&amp;my_post_key={$mybb->post_code}&amp;delete={$user[\'uid\']}" onclick="return confirm(\'{$lang->confirmdelete_who}\');" title="{$lang->remove_from_list}">
<img src="{$theme[\'imgdir\']}/buddy_delete.gif" title="[{$lang->delete}]"  alt="{$lang->remove_from_list}" style="vertical-align: middle;" />
</a>
{$username}
</li>'),
		"sid"		=> -1,
		"version"	=> 1.0,
		"dateline"	=> time(),
	);
	
	require_once MYBB_ROOT."/inc/adminfunctions_templates.php";
	
	$db->insert_query("templates", $suscriberusers_usercp_userswhosuscribers);
	$db->insert_query("templates", $suscriberusers_postbit_userfollow);
	$db->insert_query("templates", $suscriberusers_top_table);
	$db->insert_query("templates", $suscriberusers_top);
	$db->insert_query("templates", $suscriberusers_alert_bar);
	$db->insert_query("templates", $suscriberusers_usercp);
	$db->insert_query("templates", $suscriberusers_usercp_usersawaiting);
	$db->insert_query("templates", $suscriberusers_usercp_tableawaiting);
	$db->insert_query("templates", $suscriberusers_usercp_userssuscribers);
	$db->insert_query("templates", $suscriberusers_template);
	$db->insert_query("templates", $suscriberusers_list_template);
	$db->insert_query("templates", $suscriberusers_new_template);
	$db->insert_query("templates", $suscriberusers_empty_template);
	$db->insert_query("templates", $suscriberusers_postbit_template);
	$db->insert_query("templates", $suscriberusers_postbit_popup);
	$db->insert_query("templates", $suscriberusers_postbit_popup_list);
	find_replace_templatesets('member_profile', '#{\$modoptions}#', '{\$modoptions}<div id="suscriberuser">{$sususers}</div>');
	$find     = '#' . preg_quote('{$post[\'user_details\']}') . '#';
    $replace  = "{\$post['user_details']}{\$post['suscriber']}";
	find_replace_templatesets("postbit", $find, $replace, 1);
	find_replace_templatesets("postbit_classic", $find, $replace, 1);
	find_replace_templatesets("usercp_nav_misc", '#</tbody>#', '<tr><td class="trow1 smalltext"><img src="images/icons/photo.gif">&nbsp;&nbsp;<a href="usercp.php?action=suscriberawaiting">{$lang->susinvitationtem}</a></td></tr></tbody>');
	find_replace_templatesets('header', '#{\$unreadreports}#', '{$unreadreports}<!-- NewFollower -->
			{$alert_suscribers}<!-- /NewFollower -->');
	find_replace_templatesets('header', '#{\$lang->toplinks_memberlist}</a></li>#', '{\$lang->toplinks_memberlist}</a></li><!-- ListFollowerToplinks -->
					<li><a href="{\$mybb->settings[\'bburl\']}/misc.php?top=followers"><img src="{\$theme[\'imgdir\']}/toplinks/memberlist.gif" alt="" title="" />Follower List</a></li><!-- /ListFollowerToplinks -->');
}

function SuscribeUsers_deactivate() {
	global $mybb,$db,$templates;
	$db->delete_query("templates","title = 'suscriberusers'");
	$db->delete_query("templates","title = 'suscriberusers_list'");
	$db->delete_query("templates","title = 'suscriberusers_new_suscriber'");
	$db->delete_query("templates","title = 'suscriberusers_empty'");
	$db->delete_query("templates","title = 'suscriberusers_postbit'");
	$db->delete_query("templates","title = 'suscriberusers_postbit_popup'");
	$db->delete_query("templates","title = 'suscriberusers_postbit_popup_list'");
	$db->delete_query("templates","title = 'suscriberusers_usercp'");
	$db->delete_query("templates","title = 'suscriberusers_usercp_usersawaiting'");
	$db->delete_query("templates","title = 'suscriberusers_usercp_tableawaiting'");
	$db->delete_query("templates","title = 'suscriberusers_usercp_userssuscribers'");
	$db->delete_query("templates","title = 'suscriberusers_alert_bar'");
	$db->delete_query("templates","title = 'suscriberusers_top'");
	$db->delete_query("templates","title = 'suscriberusers_top_table'");
	$db->delete_query("templates","title = 'suscriberusers_postbit_userfollow'");
	$db->delete_query("templates","title = 'suscriberusers_usercp_userswhosuscribers'");
	require MYBB_ROOT."/inc/adminfunctions_templates.php";
	find_replace_templatesets("member_profile", '#<div id="suscriberuser">{\$sususers}</div>#ism', "");
	find_replace_templatesets('postbit', '#'.preg_quote('{$post[\'suscriber\']}').'#', '', 0);
	find_replace_templatesets('postbit_classic', '#'.preg_quote('{$post[\'suscriber\']}').'#', '', 0);
	find_replace_templatesets("usercp_nav_misc", "#".preg_quote('<tr><td class="trow1 smalltext"><img src="images/icons/photo.gif">&nbsp;&nbsp;<a href="usercp.php?action=suscriberawaiting">{$lang->susinvitationtem}</a></td></tr>')."#i", '', 0);
	find_replace_templatesets('header', '#\<!--\sNewFollower\s--\>(.+)\<!--\s/NewFollower\s--\>#is', '', 0);
	find_replace_templatesets('header', '#\<!--\sListFollowerToplinks\s--\>(.+)\<!--\s/ListFollowerToplinks\s--\>#is', '', 0);
}

function SuscriberUser_postbit($post){
	global $mybb,$db,$templates,$lang,$postcounter;
	$lang->load("suscriberusers", false, true);	
	$query_suscriptores = $db->query("SELECT usid FROM ".TABLE_PREFIX."suscribeusers WHERE uid='".$post['uid']."'");
    $row_suscribers = $db->num_rows($query_suscriptores);
    if($row_suscribers)
    {
        $post['suscriberusers'] = $row_suscribers;
		$post['suscriberusers'] = $post['suscriberusers'];
    }
    else 
    {
        $post['suscriberusers'] = '0';
		$post['suscriberusers'] = $post['suscriberusers'];
    }
	if($postcounter == 1)
	{
		eval("\$userfallow = \"".$templates->get("suscriberusers_postbit_userfollow")."\";");
	}
	eval("\$post['sususers'] = \"".$templates->get("suscriberusers_postbit")."\";");
	$post['suscriber'] = $post['sususers'];
	return $post;
}

function SuscribeUsers_list_postbit()
{
	global $db,$mybb,$templates,$theme,$lang,$headerinclude;
	if ($mybb->input['action'] != "suscriberuser") { return; }
	$lang->load("suscriberusers", false, true);	
	$querys = $db->query('SELECT * FROM ' . TABLE_PREFIX . 'suscribeusers WHERE uid='.$mybb->input['uid']);
	while($usuarios = $db->fetch_array($querys))
	{
		$query_user_profiles = $db->simple_select("users", "*", "uid='{$usuarios['usid']}'");
		while($user = $db->fetch_array($query_user_profiles))
		{
			$avatar_image = (!empty($user['avatar'])) ? $user['avatar'] : $mybb->settings['suscriberuser_pathimage'];
			list($max_width, $max_height) = explode("x", my_strtolower($mybb->settings['suscriberuser_size_avatar']));
			$avatar_dimensions = explode("|", $user['avatardimensions']);
			if($avatar_dimensions[0] && $avatar_dimensions[1])
			{
				if($avatar_dimensions[0] > $max_width || $avatar_dimensions[1] > $max_height)
				{
					require_once MYBB_ROOT."inc/functions_image.php";
					$scaled_dimensions = scale_image($avatar_dimensions[0], $avatar_dimensions[1], $max_width, $max_height);
					$avatar_width_height = "width=\"{$scaled_dimensions['width']}\" height=\"{$scaled_dimensions['height']}\"";
				}
				else
				{
					$avatar_width_height = "width=\"{$avatar_dimensions[0]}\" height=\"{$avatar_dimensions[1]}\"";	
				}
			}
			$bgcolor = "trow1";
			$bgcolor = alt_trow();
			$img_avatar_show = '<img src="'.$avatar_image.'" '.$avatar_width_height.'/>';
			$avatar = build_profile_link($img_avatar_show,$user['uid'],"_blank");
			$suscriberdate = my_date($mybb->settings['dateformat'], $usuarios['date']);
			$lastpost = my_date($mybb->settings['dateformat'], $user['lastpost']);
			$lastvisit = my_date($mybb->settings['dateformat'], $user['lastvisit']);
			$regdate = my_date($mybb->settings['dateformat'], $user['regdate']);
			$username = format_name($user['username'], $user['usergroup'], $user['displaygroup']);
			$username = build_profile_link($username, $user['uid']);
			$username_alt = $user['username'];
		    eval("\$listsuscriberusers .= \"".$templates->get("suscriberusers_postbit_popup_list")."\";");
		}
	}
	$query_user_input_profile = $db->write_query("SELECT * FROM ".TABLE_PREFIX."users WHERE uid=".$mybb->input[uid]);
	$user = $db->fetch_array($query_user_input_profile);
	$lang->suscribersuser = $lang->sprintf($lang->suscribersuser, $user['username']);
	$lang->userssuscriberto = $lang->sprintf($lang->userssuscriberto, $user['username']);
	$query = $db->simple_select("suscribeusers", "*", "uid='".intval($mybb->input['uid'])."'");
	$count = $db->fetch_array($query);
   if(!$count['uid']) { 
	$lang->load("report");
	$lang->thank_you = "";
	$lang->report_post = "";
	$lang->suscriber_popup_empty = $lang->sprintf($lang->suscriber_popup_empty, $user['username']);
	$lang->post_reported = $lang->suscriber_popup_empty;
	$lang->report_post = $lang->suscriberuser;
	eval("\$suscriberuser = \"".$templates->get("report_thanks")."\";");
	output_page($suscriberuser);
	}else{
	eval("\$suscriberuser = \"".$templates->get("suscriberusers_postbit_popup")."\";");
	output_page($suscriberuser);
	}
}

function SuscribeUsers_replace() {
	global $avatar,$mybb,$sususers,$sususer,$db,$user,$templates,$newsuscriber,$users_suscribers,$suscriber_new_user,$list_suscribers,$lang,$theme;
	$lang->load("suscriberusers", false, true);	
	$uid = $mybb->user[uid];
	$usid = $mybb->input[uid];
	$query = $db->simple_select('suscribeusers', 'COUNT(suid) AS suscribers', 'uid='.$usid, array('limit' => 1));
    $quantity = $db->fetch_field($query, "suscribers");
    $page = intval($mybb->input['page']);
    $perpage = $mybb->settings['suscriberuser_pagination'];
	
    if($page > 0)
	{
		$start = ($page - 1) * $perpage;
		$pages = $quantity / $perpage;
		$pages = ceil($pages);
		if($page > $pages || $page <= 0)
		{
			$start = 0;
			$page = 1;
		}
	}
	else
	{
		$start = 0;
		$page = 1;
	}
	$profile_page = 'member.php?action=profile&uid='.$usid;
	$suscriptores = array();
	$query = $db->simple_select("suscribeusers", "usid", "uid='{$usid}'");
	while($usuario = $db->fetch_array($query))
	{
		$suscriptores[] = $usuario['usid'];
	}
	$row_suscriptores = implode(",",$suscriptores);
	$user_usid = explode(",",$row_suscriptores);
	if(in_array($uid, $user_usid)){
		$sususer = ' <a href="misc.php?suscriberuser=not&amp;uid='.$uid.'&amp;usid='.$usid.'">'.$lang->unsuscriber.'</a><br />';
	}else if($usid == $uid){
		$sususer = '';
	}
	else{
		$sususer = ' <a href="misc.php?suscriberuser=yes&usid='.$usid.'&uid='.$uid.'">'.$lang->suscriber.'</a><br />';
	}
	$newsuscriber = $sususer;
	
	$users_suscribers = array();
	$querys = $db->query('SELECT * FROM ' . TABLE_PREFIX . 'suscribeusers WHERE uid='.$usid.'  ORDER BY date DESC LIMIT ' . $start . ', ' . $perpage);
	while($usuarios = $db->fetch_array($querys))
	{
		$query_user_profiles = $db->simple_select("users", "*", "uid='{$usuarios['usid']}'");
		while($user = $db->fetch_array($query_user_profiles))
		{
			$avatar_image = (!empty($user['avatar'])) ? $user['avatar'] : $mybb->settings['suscriberuser_pathimage'];
			list($max_width, $max_height) = explode("x", my_strtolower($mybb->settings['suscriberuser_size_avatar']));
			$avatar_dimensions = explode("|", $user['avatardimensions']);
			if($avatar_dimensions[0] && $avatar_dimensions[1])
			{
				if($avatar_dimensions[0] > $max_width || $avatar_dimensions[1] > $max_height)
				{
					require_once MYBB_ROOT."inc/functions_image.php";
					$scaled_dimensions = scale_image($avatar_dimensions[0], $avatar_dimensions[1], $max_width, $max_height);
					$avatar_width_height = "width=\"{$scaled_dimensions['width']}\" height=\"{$scaled_dimensions['height']}\"";
				}
				else
				{
					$avatar_width_height = "width=\"{$avatar_dimensions[0]}\" height=\"{$avatar_dimensions[1]}\"";	
				}
			}
			$img_avatar_show = '<img src="'.$avatar_image.'" '.$avatar_width_height.'/>';
			$avatar = build_profile_link($img_avatar_show,$user['uid'],"_blank");
			$suscriberdate = my_date($mybb->settings['dateformat'], $usuarios['date']);
			$lastpost = my_date($mybb->settings['dateformat'], $user['lastpost']);
			$lastvisit = my_date($mybb->settings['dateformat'], $user['lastvisit']);
			$regdate = my_date($mybb->settings['dateformat'], $user['regdate']);
			$username = format_name($user['username'], $user['usergroup'], $user['displaygroup']);
			$username = build_profile_link($username, $user['uid']);
			$username_alt = $user['username'];
			$bgcolor = "trow1";
			$bgcolor = alt_trow();
			eval("\$users_suscribers[] = \"".$templates->get("suscriberusers_list")."\";");
		}
	}
	$paginar = multipage($quantity, (int)$perpage, (int)$page, $profile_page);
	$users_suscribers = implode("",$users_suscribers);
	if(empty($users_suscribers)){
	eval("\$users_suscribers = \"".$templates->get("suscriberusers_empty")."\";");
	}
	if($mybb->user['usergroup'] == "1")
	{
		false;
	}
	else if($uid == $usid)
	{
		false;
	}
	else
	{
		eval("\$suscriber_new_user = \"".$templates->get("suscriberusers_new_suscriber")."\";");
	}
	$query_user_input_profile = $db->write_query("SELECT * FROM ".TABLE_PREFIX."users WHERE uid=".$mybb->input[uid]);
	$user = $db->fetch_array($query_user_input_profile);
	$lang->userssuscriberto = $lang->sprintf($lang->userssuscriberto, $user['username']);
	eval("\$sususers = \"".$templates->get("suscriberusers")."\";");
}

function mp_profile_link($username,$uid)
{
	global $mybb;

	if(!$username && $uid == 0)
	{
		return "Guest";
	}
	elseif($uid == 0)
	{
		return $username;
	}
	else
	{
		return "[url={$mybb->settings['bburl']}/member.php?action=profile&uid={$uid}][b]{$username}[/b][/url]";
	}
}

function SuscribeUsers_quit() {
	global $db, $mybb,$lang;
	$lang->load("suscriberusers", false, true);	
	if($mybb->input['suscriberuser'] === "not") 
	{
		if($mybb->user['usergroup'] == "1")
		{
			error_no_permission();
		}
		$uid = $mybb->input['uid'];
		$usid = $mybb->input['usid'];
		if($uid == $usid)
		{
			error($lang->error_suscriber_yourself, $lang->suscriberuser);
		}
		if($uid != $mybb->user['uid'])
		{
			error_no_permission();
		}
		if(agrege_exist($uid,$usid))
		{
			redirect("member.php?action=profile&uid=".$usid."#suscriberuser", $lang->no_exist_quit,$lang->suscriberuser);
		}
		$query_delete = $db->write_query("SELECT suid FROM ".TABLE_PREFIX."suscribeusers WHERE uid='{$usid}'  AND usid='{$uid}'");
		$delete = $db->fetch_array($query_delete);
		$db->query("DELETE FROM ".TABLE_PREFIX."suscribeusers WHERE suid='{$delete[suid]}'");
		$query_numfoll = $db->simple_select("users", "*", "uid=".$usid);
		$numfollower = $db->fetch_array($query_numfoll);
		$update_new_num_follower = array(
			'numfollowers' => --$numfollower['numfollowers']
		);
		$query = $db->update_query('users', $update_new_num_follower, 'uid='.$usid, 1);
		redirect("member.php?action=profile&uid=".$usid, $lang->unsuscriber_quit, $lang->suscriberuser);
	}
}

function SuscribeUsers_add() {
	global $db, $mybb,$lang;
	$lang->load("suscriberusers", false, true);
	$usid = $mybb->input[usid];
	$uid = $mybb->input[uid];
	if($mybb->input['suscriberuser'] == "yes") 
	{
		if($mybb->user['usergroup'] == "1")
		{
			error_no_permission();
		}
		if($uid == $usid)
		{
			error($lang->error_suscriber_yourself, $lang->suscriberuser);
		}
		if($uid != $mybb->user['uid'])
		{
			error_no_permission();
		}
		if(!agrege_exist($uid,$usid))
		{
			redirect("member.php?action=profile&uid=".$usid."#suscriberuser", $lang->double_suscription,$lang->suscriberuser);
		}
		if(user_awaiting($uid,$usid))
		{
			redirect("member.php?action=profile&uid=".$usid."#suscriberuser", $lang->double_suscription_awaiting,$lang->suscriberuser);
		}
		$asid = $db->insert_id();
		$update_table = array( 
		"uid"	 => $usid,
		"usid"	 => $uid,
		"date" => TIME_NOW
		); 
		$query_numinvs = $db->simple_select("users", "*", "uid=".$usid);
		$new_follower = $db->fetch_array($query_numinvs);
		$update_new_invitation = array(
			'newsususers' => ++$new_follower['newsususers']
		);
		$query = $db->update_query('users', $update_new_invitation, 'uid='.$usid, 1);
		$asid = $db->insert_query("suscribeusers_awaiting", $update_table);
		redirect("member.php?action=profile&uid=".$usid, $lang->suscriber_add, $lang->suscriberuser);
	}
}

function SuscribeUsers_awaiting_run()
{
	global $mybb,$db,$templates,$theme,$lang,$headerinclude,$header,$footer,$usercpnav,$plugins;
	$lang->load("suscriberusers", false, true);
	if ($mybb->input['action'] != "suscriberawaiting" && $mybb->input['action'] != "do_suscriberawaiting" && $mybb->input['action'] != "do_deletesus" && $mybb->input['action'] != "do_deletesuswho")
	{
		return;
	}
	add_breadcrumb("Invitaciones de Suscripcion");
	if($mybb->input['action'] == "do_suscriberawaiting" && $mybb->request_method == "post")
	{
		verify_post_check($mybb->input['my_post_key']);
		if($mybb->input['accept_awaiting'])
		{
			$suid = $db->insert_id();
			$update_table_accept = array( 
			"uid"	 => $mybb->user['uid'],
			"usid"	 => $mybb->input['uid'],
			"date" => $mybb->input['date']
			); 
			$suid = $db->insert_query("suscribeusers", $update_table_accept);
			$query_numfoll = $db->simple_select("users", "*", "uid=".$mybb->user['uid']);
			$numfollower = $db->fetch_array($query_numfoll);
			$update_new_num_follower = array(
				'numfollowers' => ++$numfollower['numfollowers']
			);
			$query = $db->update_query('users', $update_new_num_follower, 'uid='.$mybb->user['uid'], 1);
			$delete_awaiting_accept = $db->write_query("SELECT asid FROM ".TABLE_PREFIX."suscribeusers_awaiting WHERE uid='{$mybb->user['uid']}'  AND usid='{$mybb->input['uid']}'");
			$delete_invitation = $db->fetch_array($delete_awaiting_accept);
			$db->query("DELETE FROM ".TABLE_PREFIX."suscribeusers_awaiting WHERE asid='{$delete_invitation[asid]}'");
			if($mybb->input['send_mp'])
			{
				SuscribeUsers_pm_accept_reject($mybb->user['uid'],$mybb->input['uid'],$lang->accept_mp);
			}
			$lang->acceptinvitation = $lang->sprintf($lang->acceptinvitation, $mybb->input['username']);
			redirect("usercp.php",$lang->acceptinvitation);
		}
		if($mybb->input['reject_awaiting'])
		{
			$delete_awaiting_reject = $db->write_query("SELECT asid FROM ".TABLE_PREFIX."suscribeusers_awaiting WHERE uid='{$mybb->user['uid']}'  AND usid='{$mybb->input['uid']}'");
			$delete_invitation_reject = $db->fetch_array($delete_awaiting_reject);
			$db->query("DELETE FROM ".TABLE_PREFIX."suscribeusers_awaiting WHERE asid='{$delete_invitation_reject[asid]}'");
			if($mybb->input['send_mp'])
			{
				SuscribeUsers_pm_accept_reject($mybb->user['uid'],$mybb->input['uid'],$lang->reject_mp);
			}
			$lang->rejectinvitation = $lang->sprintf($lang->rejectinvitation, $mybb->input['username']);
			redirect("usercp.php",$lang->rejectinvitation);
		}
	}
	if($mybb->input['action'] == "do_deletesus")
	{
		verify_post_check($mybb->input['my_post_key']);
		if($mybb->user['usergroup'] == "1")
		{
			error_no_permission();
		}
		$uid = $mybb->user['uid'];
		$usid = $mybb->input['delete'];
		if($uid == $usid)
		{
			error($lang->error_suscriber_yourself, $lang->suscriberuser);
		}
		if($uid != $mybb->user['uid'])
		{
			error_no_permission();
		}
		if(agrege_exist($usid,$uid))
		{
			redirect("member.php?action=profile&uid=".$usid."#suscriberuser", $lang->no_exist_quit,$lang->suscriberuser);
		}
		$query_delete_sus_user = $db->write_query("SELECT suid FROM ".TABLE_PREFIX."suscribeusers WHERE uid='{$uid}'  AND usid='{$usid}'");
		$delete_sus_users = $db->fetch_array($query_delete_sus_user);
		$db->query("DELETE FROM ".TABLE_PREFIX."suscribeusers WHERE suid='{$delete_sus_users[suid]}'");
		$query_numfoll = $db->simple_select("users", "*", "uid=".$mybb->user['uid']);
		$numfollower = $db->fetch_array($query_numfoll);
		$update_new_num_follower = array(
			'numfollowers' => --$numfollower['numfollowers']
		);
		$query = $db->update_query('users', $update_new_num_follower, 'uid='.$mybb->user['uid'], 1);
		redirect("usercp.php", $lang->unsuscriber_quit_usercp, $lang->suscriberuser);
	}
	if($mybb->input['action'] == "do_deletesuswho")
	{
		verify_post_check($mybb->input['my_post_key']);
		if($mybb->user['usergroup'] == "1")
		{
			error_no_permission();
		}
		$uid = $mybb->user['uid'];
		$usid = $mybb->input['delete'];
		if($uid == $usid)
		{
			error($lang->error_suscriber_yourself, $lang->suscriberuser);
		}
		if($uid != $mybb->user['uid'])
		{
			error_no_permission();
		}
		if(agrege_exist($uid,$usid))
		{
			redirect("member.php?action=profile&uid=".$usid."#suscriberuser", $lang->no_exist_quit,$lang->suscriberuser);
		}
		$query_delete_sus_user = $db->write_query("SELECT suid FROM ".TABLE_PREFIX."suscribeusers WHERE uid='{$usid}'  AND usid='{$uid}'");
		$delete_sus_users = $db->fetch_array($query_delete_sus_user);
		$db->query("DELETE FROM ".TABLE_PREFIX."suscribeusers WHERE suid='{$delete_sus_users[suid]}'");
		$query_numfolluser = $db->simple_select("users", "*", "uid=".$usid);
		$numfollower_user = $db->fetch_array($query_numfolluser);
		$update_new_num_follower_delete = array(
			'numfollowers' => --$numfollower_user['numfollowers']
		);
		$query = $db->update_query('users', $update_new_num_follower_delete, 'uid='.$usid, 1);
		redirect("usercp.php", $lang->unsuscriber_quit_usercp_who, $lang->suscriberuser);
	}
	$plugins->run_hooks("usercp_suscriber_users_start");
	$query = $db->query("SELECT asid FROM ".TABLE_PREFIX."suscribeusers_awaiting WHERE uid=".$mybb->user['uid']);
    $invitations = $db->num_rows($query);
	$query_sus = $db->query("SELECT suid FROM ".TABLE_PREFIX."suscribeusers WHERE uid=".$mybb->user['uid']);
    $subscribedtoyou_lang = $db->num_rows($query_sus);
	$lang->invitations_suscribers = $lang->sprintf($lang->invitations_suscribers, $invitations);
	$lang->subscribedtoyou = $lang->sprintf($lang->subscribedtoyou, $subscribedtoyou_lang);
	$query_users_awaiting = $db->simple_select("suscribeusers_awaiting", "*", "uid=".$mybb->user['uid']);
	while($usid_awaiting = $db->fetch_array($query_users_awaiting))
	{
		$query_users = $db->simple_select("users", "*", "uid=".$usid_awaiting['usid']);
		while($user = $db->fetch_array($query_users))
		{
			$bgcolor = "trow1";
			$bgcolor = alt_trow();
			$username = format_name($user['username'], $user['usergroup'], $user['displaygroup']);
			$username = build_profile_link($username, $user['uid']);
			$suscriber_date = $usid_awaiting['date'];
			eval("\$usersawaiting .= \"".$templates->get("suscriberusers_usercp_usersawaiting")."\";");
		}
	unset($user);
	}
	if($invitations != 0)
	{
		eval("\$tableawaiting = \"".$templates->get("suscriberusers_usercp_tableawaiting")."\";");
	}
	else
	{
		$tableawaiting = $lang->emptyawaiting;
	}
	if($subscribedtoyou_lang != 0)
	{
		$query_users_suscribers = $db->simple_select("suscribeusers", "*", "uid=".$mybb->user['uid']);
		while($usid_suscribers = $db->fetch_array($query_users_suscribers))
		{
			$query_userssuscribers = $db->simple_select("users", "*", "uid=".$usid_suscribers['usid']);
			while($user = $db->fetch_array($query_userssuscribers))
			{
				$bgcolor = "trow1";
				$bgcolor = alt_trow();
				$username = format_name($user['username'], $user['usergroup'], $user['displaygroup']);
				$username = build_profile_link($username, $user['uid']);
				eval("\$subscribedtoyou .= \"".$templates->get("suscriberusers_usercp_userssuscribers")."\";");
			}
		}
	}
	else
	{
		$subscribedtoyou = $lang->emptysuscriberuserslist;
	}
	$query_usid = $db->query("SELECT suid FROM ".TABLE_PREFIX."suscribeusers WHERE usid=".$mybb->user['uid']);
    $subscribedtoyou_usid = $db->num_rows($query_usid);
	$lang->userstofollow = $lang->sprintf($lang->userstofollow, $subscribedtoyou_usid);
	if($subscribedtoyou_usid != 0)
	{
		$query_users_suscribers_usid = $db->simple_select("suscribeusers", "*", "usid=".$mybb->user['uid']);
		while($usid_suscribersusid = $db->fetch_array($query_users_suscribers_usid))
		{
			$query_userssuscribersusid = $db->simple_select("users", "*", "uid=".$usid_suscribersusid['uid']);
			while($user = $db->fetch_array($query_userssuscribersusid))
			{
				$bgcolor = "trow1";
				$bgcolor = alt_trow();
				$username = format_name($user['username'], $user['usergroup'], $user['displaygroup']);
				$username = build_profile_link($username, $user['uid']);
				eval("\$subscribed_you .= \"".$templates->get("suscriberusers_usercp_userswhosuscribers")."\";");
			}
		}
	}
	else
	{
		$subscribed_you = $lang->emptysuscriberuserslistwho;
	}
	eval("\$suscriber_awaiting = \"".$templates->get("suscriberusers_usercp")."\";");
	output_page($suscriber_awaiting);
}

function SuscribeUsers_pm($object)
{
	global $mybb,$db,$cache;
	$thread = &$object->data;
	require_once MYBB_ROOT."inc/datahandlers/pm.php";
	$pmhandler = new PMDataHandler();
	$usuarios = array();
	$query = $db->simple_select("suscribeusers", "usid", "uid = '{$mybb->user['uid']}'");
	while($usuario = $db->fetch_array($query))
	{
		$usuarios[] = $usuario['usid'];
	}
	$query_name_forum = $db->write_query("SELECT name FROM ".TABLE_PREFIX."forums WHERE fid=".$thread['fid']);
	$forum = $db->fetch_array($query_name_forum);
	$subject = $mybb->settings['suscriberuser_subject'];
	$subject = preg_replace("!\{author\}!Us",$thread['username'], $subject);
	$message = $mybb->settings['suscriberuser_body'];
	$message = preg_replace("!\{bbname\}!Us",$mybb->settings['bbname'], $message);
	$message = preg_replace("!\{author\}!Us",mp_profile_link($thread['username'],$thread['uid']), $message);
	$message = preg_replace("!\{subject\}!Us","[b]".$thread['subject']."[/b]", $message);
	$message = preg_replace("!\{forum\}!Us","[url=".$mybb->settings['bburl']."/forumdisplay.php?fid=".$thread['fid']."][b]".$forum['name']."[/b][/url]", $message);
	$message = preg_replace("!\{subjectlink\}!Us","[url={$mybb->settings['bburl']}/showthread.php?tid={$object->tid}][b]".$thread['subject']."[/b][/url]", $message);
	$pm = array(
		'subject' => $subject,
		'message' => $message,
		'icon' => '',
		'toid' => $usuarios,
		'fromid' => $mybb->user['uid'],
		"do" => '',
		"pmid" => '',
	);
	$pm['options'] = array(
		'signature' => '0',
		'savecopy' => '0',
		'disablesmilies' => '0',
		'readreceipt' => '0',
	);

	$pmhandler->set_data($pm);
	$valid_pm = $pmhandler->validate_pm();
	if( $valid_pm)
	{
		$pmhandler->insert_pm();
	}
}


function user_awaiting($uid,$usid)
{
	global $db;
	$query = $db->simple_select("suscribeusers_awaiting", "COUNT(*) as asid", "uid='{$usid}' and usid=".$uid, array('limit' => 1));
	if($db->fetch_field($query, 'asid') == 1)
	{
		return true;
	}
	else
	{
		return false;
	}
}

function agrege_exist($uid,$usid)
{
	global $db;
	$query = $db->query("SELECT suid FROM ".TABLE_PREFIX."suscribeusers WHERE uid='{$usid}' AND usid='{$uid}'");
	$count = $db->num_rows($query);
	if($count == 0)
	{
		return true;
	}
	else
	{
		return false;
	}
}

function newsususers_invitation()
{
	global $mybb, $db, $templates, $lang, $alert_suscribers, $comment_inmenu;
	$lang->load("suscriberusers", false, true);
	$num_follower = $mybb->user['newsususers'];

	if($mybb->user['uid'] != 0 && $num_follower > 0)
	{	$lang->textalertbar = $lang->sprintf($lang->textalertbar, $num_follower);
		eval("\$alert_suscribers = \"".$templates->get("suscriberusers_alert_bar")."\";");
	}
}

function newsususers_invitation_as_read()
{
	global $db,$mybb;
	if(empty($mybb->user['uid']))
	{
		return false;
	}
	if($mybb->user['newsususers'])
	{
		$delete_new_invitation = array(
			'newsususers' => 0
		);
		$db->update_query('users', $delete_new_invitation, 'uid='.$mybb->user['uid'], 1);
	}
}

function suscriberusers_whosonline(&$plugin_array)
{
	global $lang;
	$lang->load("suscriberusers", false, true);
	if(preg_match('/usercp\.php\?action\=suscriberawaiting/',$plugin_array['user_activity']['location']))
	{
		$plugin_array['location_name'] = $lang->susonline;
	}
	return $plugin_array;
}

function SuscribeUsers_pm_accept_reject($uid,$usid,$invitation)
{
	global $mybb,$db,$cache;
	$query_user = $db->write_query("SELECT * FROM ".TABLE_PREFIX."users WHERE uid=".$uid);
	$user = $db->fetch_array($query_user);
	$subject = $mybb->settings['suscriberuser_subject_accept'];
	$subject = preg_replace("!\{sususer\}!Us",$user['username'], $subject);
	$body = $mybb->settings['suscriberuser_body_accept'];
	$body = preg_replace("!\{bbname\}!Us",$mybb->settings['bbname'], $body);
	$body = preg_replace("!\{sususer\}!Us",mp_profile_link($user['username'],$user['uid']), $body);
	$body = preg_replace("!\{invitation\}!Us",$invitation, $body);
	require_once MYBB_ROOT."inc/datahandlers/pm.php";
	$pmhandler = new PMDataHandler();

	$pm = array(
		'subject' => $subject,
		'message' => $body,
		'icon' => '',
		'toid' => array($usid),
		'fromid' => $uid,
		"do" => '',
		"pmid" => '',

	);

	$pm['options'] = array(
	'signature' => '0',
	'savecopy' => '0',
	'disablesmilies' => '0',
	'readreceipt' => '0',
	);

	$pmhandler->set_data($pm);
	$valid_pm = $pmhandler->validate_pm();

	if( $valid_pm)
	{
		$pmhandler->insert_pm();
	}
}

function suscriberusers_suscribers_stats()
{
	global $db,$mybb,$headerinclude,$header,$footer;
	global $templates,$theme,$cache,$lang;
	$lang->load("suscriberusers", false, true);
	if ($mybb->input['top'] != "followers")
	{
		return;
	}
	add_breadcrumb($lang->nav_followerlist);
	$query = $db->simple_select('users', 'COUNT(uid) AS user', '', array('limit' => 1));
    $quantity = $db->fetch_field($query, "user");
    $page = intval($mybb->input['page']);
    $perpage = intval($mybb->settings['suscriberuser_listfollower_perpage']);
	
    if($page > 0)
	{
		$start = ($page - 1) * $perpage;
		$pages = $quantity / $perpage;
		$pages = ceil($pages);
		if($page > $pages || $page <= 0)
		{
			$start = 0;
			$page = 1;
		}
	}
	else
	{
		$start = 0;
		$page = 1;
	}
	$urlpage = 'misc.php?top=followers';
	
	$usergroups_cache = $cache->read('usergroups');
	$query = $db->simple_select("usertitles", "*", "", array('order_by' => 'posts', 'order_dir' => 'DESC'));
	while($usertitle = $db->fetch_array($query))
	{
		$usertitles_cache[$usertitle['posts']] = $usertitle;
	}
	$querys = $db->query("
		SELECT u.*, f.*
		FROM ".TABLE_PREFIX."users u
		LEFT JOIN ".TABLE_PREFIX."userfields f ON (f.ufid=u.uid)
		ORDER BY numfollowers DESC
		LIMIT {$start}, {$perpage}
	");
	while($user = $db->fetch_array($querys))
	{
		$bgcolor = "trow1";
		$bgcolor = alt_trow();
		$user['username'] = format_name($user['username'], $user['usergroup'], $user['displaygroup']);

		$user['profilelink'] = build_profile_link($user['username'], $user['uid']);
		if(!$user['displaygroup'])
		{
			$user['displaygroup'] = $user['usergroup'];
		}
		$usergroup = $usergroups_cache[$user['displaygroup']];

		if($mybb->settings['usereferrals'] == 1)
		{
			eval("\$referral_bit = \"".$templates->get("memberlist_referrals_bit")."\";");
		}
		
		if(!empty($usergroup['image']))
		{
			if(!empty($mybb->user['language']))
			{
				$language = $mybb->user['language'];
			}
			else
			{
				$language = $mybb->settings['bblanguage'];
			}
			$usergroup['image'] = str_replace("{lang}", $language, $usergroup['image']);
			$usergroup['image'] = str_replace("{theme}", $theme['imgdir'], $usergroup['image']);
			eval("\$usergroup['groupimage'] = \"".$templates->get("memberlist_user_groupimage")."\";");
		}

		$has_custom_title = 0;
		if(trim($user['usertitle']) != "")
		{
			$has_custom_title = 1;
		}

		if($usergroup['usertitle'] != "" && !$has_custom_title)
		{
			$user['usertitle'] = $usergroup['usertitle'];
		}
		elseif(is_array($usertitles_cache) && !$usergroup['usertitle'])
		{
			foreach($usertitles_cache as $posts => $titleinfo)
			{
				if($user['postnum'] >= $posts)
				{
					if(!$has_custom_title)
					{
						$user['usertitle'] = $titleinfo['title'];
					}
					$user['stars'] = $titleinfo['stars'];
					$user['starimage'] = $titleinfo['starimage'];
					break;
				}
			}
		}

		if($usergroup['stars'])
		{
			$user['stars'] = $usergroup['stars'];
		}

		if(!$user['starimage'])
		{
			$user['starimage'] = $usergroup['starimage'];
		}
		
		if($user['starimage'])
		{
			$starimage = str_replace("{theme}", $theme['imgdir'], $user['starimage']);
			$user['userstars'] = '';

			for($i = 0; $i < $user['stars']; ++$i)
			{
				$user['userstars'] .= "<img src=\"{$starimage}\" border=\"0\" alt=\"*\" />";
			}
		}

		if($user['userstars'] && $usergroup['groupimage'])
		{
			$user['userstars'] = "<br />".$user['userstars'];
		}
	
		if($user['avatar'] != '')
		{
			$user['avatar'] = htmlspecialchars_uni($user['avatar']);
			$avatar_dimensions = explode("|", $user['avatardimensions']);
			if($avatar_dimensions[0] && $avatar_dimensions[1])
			{
				list($max_width, $max_height) = explode("x", my_strtolower($mybb->settings['memberlistmaxavatarsize']));
			 	if($avatar_dimensions[0] > $max_width || $avatar_dimensions[1] > $max_height)
				{
					require_once MYBB_ROOT."inc/functions_image.php";
					$scaled_dimensions = scale_image($avatar_dimensions[0], $avatar_dimensions[1], $max_width, $max_height);
					$avatar_width_height = "width=\"{$scaled_dimensions['width']}\" height=\"{$scaled_dimensions['height']}\"";
				}
				else
				{
					$avatar_width_height = "width=\"{$avatar_dimensions[0]}\" height=\"{$avatar_dimensions[1]}\"";	
				}
			}
			eval("\$user['avatar'] = \"".$templates->get("memberlist_user_avatar")."\";");
		}
		else
		{
			$user['avatar'] = "";
		}		
		
		$user['regdate'] = my_date($mybb->settings['dateformat'], $user['regdate']).", ".my_date($mybb->settings['timeformat'], $user['regdate']);
		$user['lastvisit'] = my_date($mybb->settings['dateformat'], $user['lastactive']).", ".my_date($mybb->settings['timeformat'], $user['lastactive']);
		$user['numfollowers'] = "<a href=\"javascript:MyBB.popupWindow('misc.php?action=suscriberuser&amp;uid={$user['uid']}', 'SuscriberUser', 400, 300);\">{$user['numfollowers']}</a>";
		eval("\$top_followers .= \"".$templates->get("suscriberusers_top_table")."\";");
	}
	$pagination = multipage($quantity, (int)$perpage, (int)$page, $urlpage);
	eval("\$suscriber_stats = \"".$templates->get("suscriberusers_top")."\";");
	output_page($suscriber_stats);
}
?>